# -*- coding: utf-8 -*-
# © 2019 and later: Unicode, Inc. and others.
# License & terms of use: http://www.unicode.org/copyright.html#License

data = {
    "cldrVersion": "35.1",
    "aliases": {
        "ars": "ar_SA",
        "az_AZ": "az_Latn_AZ",
        "bs_BA": "bs_Latn_BA",
        "en_NH": "en_VU",
        "en_RH": "en_ZW",
        "ff_CM": "ff_Latn_CM",
        "ff_GN": "ff_Latn_GN",
        "ff_MR": "ff_Latn_MR",
        "ff_SN": "ff_Latn_SN",
        "in": "id",
        "in_ID": "id_ID",
        "iw": "he",
        "iw_IL": "he_IL",
        "mo": "ro",
        "no_NO": "nb_NO",
        "no_NO_NY": "nn_NO",
        "no": "nb",
        "pa_IN": "pa_Guru_IN",
        "pa_PK": "pa_Arab_PK",
        "sh": "sr_Latn",
        "sh_BA": "sr_Latn_BA",
        "sh_CS": "sr_Latn_RS",
        "sh_YU": "sr_Latn_RS",
        "shi_MA": "shi_Tfng_MA",
        "sr_BA": "sr_Cyrl_BA",
        "sr_CS": "sr_Cyrl_RS",
        "sr_ME": "sr_Latn_ME",
        "sr_RS": "sr_Cyrl_RS",
        "sr_XK": "sr_Cyrl_XK",
        "sr_YU": "sr_Cyrl_RS",
        "sr_Cyrl_YU": "sr_Cyrl_RS",
        "sr_Cyrl_CS": "sr_Cyrl_RS",
        "sr_Latn_YU": "sr_Latn_RS",
        "sr_Latn_CS": "sr_Latn_RS",
        "tl": "fil",
        "tl_PH": "fil_PH",
        "uz_AF": "uz_Arab_AF",
        "uz_UZ": "uz_Latn_UZ",
        "vai_LR": "vai_Vaii_LR",
        "yue_CN": "yue_Hans_CN",
        "yue_HK": "yue_Hant_HK",
        "zh_CN": "zh_Hans_CN",
        "zh_HK": "zh_Hant_HK",
        "zh_MO": "zh_Hant_MO",
        "zh_SG": "zh_Hans_SG",
        "zh_TW": "zh_Hant_TW"
    },
    "parents": {
        "ff_Adlm": "root",
        "en_CM": "en_001",
        "so_Arab": "root",
        "en_KY": "en_001",
        "en_TC": "en_001",
        "yue_Hans": "root",
        "en_CX": "en_001",
        "es_EC": "es_419",
        "es_US": "es_419",
        "byn_Latn": "root",
        "en_CY": "en_001",
        "en_LC": "en_001",
        "en_TK": "en_001",
        "tg_Arab": "root",
        "es_UY": "es_419",
        "ky_Latn": "root",
        "en_TO": "en_001",
        "en_TT": "en_001",
        "en_DE": "en_150",
        "es_MX": "es_419",
        "en_TV": "en_001",
        "en_DG": "en_001",
        "pt_ST": "pt_PT",
        "en_DM": "en_001",
        "en_LR": "en_001",
        "en_TZ": "en_001",
        "en_LS": "en_001",
        "en_DK": "en_150",
        "blt_Latn": "root",
        "es_VE": "es_419",
        "es_NI": "es_419",
        "sd_Khoj": "root",
        "pt_AO": "pt_PT",
        "en_UG": "en_001",
        "yo_Arab": "root",
        "dje_Arab": "root",
        "en_MG": "en_001",
        "en_MO": "en_001",
        "en_MU": "en_001",
        "en_MS": "en_001",
        "en_MT": "en_001",
        "shi_Latn": "root",
        "es_BR": "es_419",
        "en_AU": "en_001",
        "en_ZM": "en_001",
        "en_AT": "en_150",
        "es_BZ": "es_419",
        "uz_Arab": "root",
        "az_Cyrl": "root",
        "es_SV": "es_419",
        "en_ZW": "en_001",
        "en_JE": "en_001",
        "en_BB": "en_001",
        "sd_Deva": "root",
        "pa_Arab": "root",
        "en_RW": "en_001",
        "es_CO": "es_419",
        "en_JM": "en_001",
        "en_BE": "en_150",
        "dyo_Arab": "root",
        "es_CL": "es_419",
        "en_BM": "en_001",
        "en_SC": "en_001",
        "es_CR": "es_419",
        "en_150": "en_001",
        "en_BS": "en_001",
        "en_SD": "en_001",
        "pt_GQ": "pt_PT",
        "en_SB": "en_001",
        "es_CU": "es_419",
        "en_SG": "en_001",
        "uz_Cyrl": "root",
        "en_BW": "en_001",
        "en_SH": "en_001",
        "en_SE": "en_150",
        "pt_GW": "pt_PT",
        "ky_Arab": "root",
        "en_BZ": "en_001",
        "en_SL": "en_001",
        "en_SI": "en_150",
        "ff_Arab": "root",
        "en_KE": "en_001",
        "bm_Nkoo": "root",
        "en_CC": "en_001",
        "en_SS": "en_001",
        "iu_Latn": "root",
        "en_CA": "en_001",
        "en_KI": "en_001",
        "es_DO": "es_419",
        "en_SX": "en_001",
        "en_CH": "en_150",
        "en_KN": "en_001",
        "en_CK": "en_001",
        "ml_Arab": "root",
        "en_SZ": "en_001",
        "pt_FR": "pt_PT",
        "ug_Cyrl": "root",
        "en_GY": "en_001",
        "en_PH": "en_001",
        "en_PG": "en_001",
        "en_PK": "en_001",
        "cu_Glag": "root",
        "en_PN": "en_001",
        "kk_Arab": "root",
        "en_HK": "en_001",
        "zh_Hant": "root",
        "en_PW": "en_001",
        "es_AR": "es_419",
        "pt_MZ": "pt_PT",
        "sd_Sind": "root",
        "en_Shaw": "root",
        "en_IE": "en_001",
        "ms_Arab": "root",
        "en_IM": "en_001",
        "en_IN": "en_001",
        "es_BO": "es_419",
        "en_IL": "en_001",
        "en_AI": "en_001",
        "az_Arab": "root",
        "en_AG": "en_001",
        "en_IO": "en_001",
        "en_ZA": "en_001",
        "en_MY": "en_001",
        "en_ER": "en_001",
        "en_VC": "en_001",
        "mn_Mong": "root",
        "vai_Latn": "root",
        "en_MW": "en_001",
        "pt_LU": "pt_PT",
        "bs_Cyrl": "root",
        "en_VG": "en_001",
        "en_NA": "en_001",
        "en_NF": "en_001",
        "en_NG": "en_001",
        "ha_Arab": "root",
        "en_NL": "en_150",
        "zh_Hant_MO": "zh_Hant_HK",
        "en_VU": "en_001",
        "en_FJ": "en_001",
        "en_NR": "en_001",
        "en_FK": "en_001",
        "es_GT": "es_419",
        "en_FI": "en_150",
        "ku_Arab": "root",
        "pt_MO": "pt_PT",
        "en_FM": "en_001",
        "en_NU": "en_001",
        "en_NZ": "en_001",
        "pt_CH": "pt_PT",
        "en_Dsrt": "root",
        "es_PE": "es_419",
        "es_PA": "es_419",
        "pt_CV": "pt_PT",
        "wo_Arab": "root",
        "en_WS": "en_001",
        "en_GD": "en_001",
        "en_GB": "en_001",
        "es_HN": "es_419",
        "pt_TL": "pt_PT",
        "en_GG": "en_001",
        "en_GH": "en_001",
        "es_PR": "es_419",
        "sw_Arab": "root",
        "en_GI": "en_001",
        "sr_Latn": "root",
        "en_GM": "en_001",
        "es_PY": "es_419"
    }
}
